"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require("react");
var assign = require("object-assign");
var style = {
    swatches: {
        textAlign: "center",
        padding: "0",
        border: "1px solid rgba(0,0,0,0.1)",
        borderRadius: "4px",
        cursor: "pointer",
        display: "inline-block",
        width: "175px",
        verticalAlign: "top",
        wordWrap: "break-word",
    },
    swatch: {
        height: "80px",
        borderRadius: "4px 4px 0 0",
        transition: "opacity 0.25s ease-in-out",
        borderBottom: "1px solid rgba(0,0,0,0.1)",
    },
    listStyle: { listStyle: "none" },
    pushBottom: { marginBottom: "10px" },
    pushLeft: { marginLeft: "10px" },
    soft: { paddingLeft: "10px", paddingRight: "10px" },
    hard: { padding: "0" },
    flush: { margin: "0" },
    font: {
        fontFamily: "-apple-system, '.SFNSText-Regular', 'San Francisco', Roboto, 'Segoe UI', 'Helvetica Neue', 'Lucida Grande', sans-serif",
        fontSize: "14px",
    },
};
var Swatch = (function (_super) {
    __extends(Swatch, _super);
    function Swatch() {
        var _this = this;
        _super.apply(this, arguments);
        this.state = { selected: null };
        this.onBackgroundChange = function () {
            var _a = _this.props, value = _a.value, channel = _a.channel;
            channel.emit("background", value);
        };
    }
    Swatch.prototype.componentWillMount = function () {
        this.setState({ selected: this.props.value });
    };
    Swatch.prototype.render = function () {
        return (React.createElement("div", {style: assign({}, style.swatches, style.listStyle, style.hard), onClick: this.onBackgroundChange}, React.createElement("div", {style: assign({}, style.swatch, {
            background: this.props.value,
            "backgroundSize": "cover",
            "backgroundPosition": "center",
        })}), React.createElement("div", {style: assign({}, style.listStyle, style.soft)}, React.createElement("h4", {style: assign({ float: "left", fontWeight: "bold" }, style.font)}, this.props.name, ":"), React.createElement("h4", {style: assign({ float: "right", fontWeight: "normal" }, style.font)}, React.createElement("em", null, this.props.value)))));
    };
    return Swatch;
}(React.Component));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Swatch;
//# sourceMappingURL=Swatch.js.map